#include "interrupt.h"
#include "hwd_interrupt.h"

/**
 * @brief Default Handler
 * 
 * This handler is called when no interrupt handler was set
 */
static void defaultHandler(){};

void intInit(
		intrType_t intType,
		intHandler_t handler,	
		uint8_t priority)
{
	NVIC_SetPriority(interruptTypeIndexList[intType], priority);

	// TODO: add index ceck!
	intHandlerList[intType] = (uint32_t)handler; 
}

void intEnableAll()
{
	__enable_irq();
}

void intDissableAll()
{
	__disable_irq();
}

void intEnable(
		intrType_t intType)
{
	NVIC_EnableIRQ(interruptTypeIndexList[intType]);
}

void intDissable(
		intrType_t intType)
{
	NVIC_DisableIRQ(interruptTypeIndexList[intType]);
}

